package require Tk

proc Tile { phImg xRepeat yRepeat } {
    set startTime [clock milliseconds]
    set w [image width  $phImg]
    set h [image height $phImg]
    set w2 [expr {$w * $xRepeat}]
    set h2 [expr {$h * $yRepeat}]

    set tileImg [image create photo -width $w2 -height $h2]

    for { set x 0 } { $x < $xRepeat } { incr x } {
        for { set y 0 } { $y < $yRepeat } { incr y } {
            $tileImg copy $phImg -to [expr {$x*$w}] [expr {$y*$h}] -compositingrule set
        }
    }
    set endTime [clock milliseconds]
    puts [format "Time for %4d copies: %5.2f seconds (%3d milliseconds / copy)" \
         [expr {$xRepeat * $yRepeat}] \
         [expr { ($endTime - $startTime) / 1000.0 }] \
         [expr { ($endTime - $startTime) / ($xRepeat * $yRepeat) }]]
    return $tileImg
}

puts "Using Tcl [info patch], Tk $tk_patchLevel"

set files {"Balls-3chan.png" "Balls-4chan-transp.png" "Balls-4chan-opaque.png" "Balls-4chan-partial.png"}
foreach f $files {
    puts "Using file $f"
    set srcImg [image create photo -file $f]
    set phImg [Tile $srcImg 10 10] ; image delete $phImg
    set phImg [Tile $srcImg 20 20] ; image delete $phImg
    image delete $srcImg
}

exit
